$crystal = 8000000                                          '   8

'  
Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.3 , Rs = Portb.2
Config Lcd = 16 * 2                                         ' 16  2 
Cursor Off                                                  ' 
Cls                                                         '  

Config Scl = Portb.0                                        ' I2C SCL
Config Sda = Portb.1                                        ' I2C SDA

Config Portd = Input                                        '   
Portd = 255                                                 '  

Const Tea = 128                                             ' SLAVE ADRESS TEA6300

' 
Dim M As Byte                                               ' 
Dim Datas(6) As Byte                                        ' 
Dim Max_sets As Byte                                        '   
Dim Subadr As Byte                                          '  TEA6300


'    TEA6300
For M = 1 To 6
If Subadr = 4 Then                                          '     (FADER)
                Datas(m) = 63                               'FADER FRONT 
                Gosub Write_data                            '      TEA6300
                Datas(m) = 47                               'FADER REAR 
              Else
                If Subadr = 5 Then                          '      MUTE
                                Datas(m) = 1                '  INLA, INRA, MUTE 
                              Else
                                Datas(m) = 0                '   0
                End If
End If
Gosub Write_data                                            '      TEA6300
Next

M = 1

Do                                                          '  

Locate 1 , 1                                                '   1 , 1 

If M = 1 Then                                               ' M=1      
            Lcd "Volume L"
            Max_sets = 63
End If

If M = 2 Then                                               ' M=2      
            Lcd "Volume R"
            Max_sets = 63
End If


If M = 3 Then                                               ' M=3     
            Lcd "BASS"
            Max_sets = 15
End If

If M = 4 Then                                               ' M=4     
            Lcd "TREBLE"
            Max_sets = 15
End If

Locate 2 , 1                                                '   2 , 1 
Lcd Datas(m) ; "  "                                         '   


' 
If Pind.0 = 0 Then                                          '   S1
                    If Datas(m) > 0 Then Decr Datas(m)      '    0,    1
                    Gosub Write_data                        '      TEA6300
                    Waitms 100                              ' 100 
End If


If Pind.1 = 0 Then                                          '   S2
                    If Datas(m) < Max_sets Then Incr Datas(m)       '    Max_sets,    1
                    Gosub Write_data                        '      TEA6300
                    Waitms 100                              ' 100 
End If


' 
If Pind.2 = 0 Then                                          '   S3
                    If M > 1 Then Decr M                    '     1,    1
                    Cls                                     '  
                    Waitms 300                              ' 300 
End If


If Pind.3 = 0 Then                                          '   S4
                    If M < 4 Then Incr M                    '     4,    1
                    Cls                                     '  
                    Waitms 300                              ' 300 
End If

Loop                                                        '   

Write_data:                                                 ' I2C
'*******************************************************************************
Subadr = M - 1

I2cstart                                                    'I2C START
I2cwbyte Tea                                                'SLAVE ADRESS TEA6300
I2cwbyte Subadr                                             'SUBADRESS  TEA6300
I2cwbyte Datas(m)                                           '   TEA6300
I2cstop                                                     'I2C STOP
Waitms 10                                                   ' 10 
Return


End                                                         ' 