$crystal = 8000000                                          '   8

'  
Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.3 , Rs = Portb.2
Config Lcd = 16 * 2                                         ' 16  2 
Cursor Off                                                  ' 


Config Scl = Portb.0                                        ' I2C SCL
Config Sda = Portb.1                                        ' I2C SDA

Config Portd = Input                                        '   
Portd = 255                                                 '  

' 
Dim Temp As Byte
Dim Freq As Long
Dim Freq_d As Single
Dim Freq_1 As Long
Dim Freq_2 As Long

Freq = 88000                                                ' 
Gosub Write_tsa                                             '      TSA6057

Do                                                          '  

Locate 1 , 1                                                '   1 , 1 
Lcd "Frequency"
Locate 2 , 1                                                '   2 , 1 
Lcd Fusing(freq_d , "#.#") ; " MHz"                         '   freq_d, 1   

If Pind.0 = 0 Then                                          '   S1
               If Freq > 88000 Then                         '     88000 
                                Freq = Freq - 100           '     100 
                                Gosub Write_tsa             '      TSA6057
               End If
End If

If Pind.1 = 0 Then                                          '   S2
                 If Freq < 108000 Then                      '     108000 
                                    Freq = Freq + 100       '     100 
                                    Gosub Write_tsa         '      TSA6057
                 End If
End If

Loop

Write_tsa:
'******************************************************************************
Freq_1 = Freq - 10700                                       '  
Freq_d = Freq / 1000                                        '    

I2cstart                                                    'I2C START
Temp = &B11000100
I2cwbyte Temp                                               'SLAVE ADRESS TSA6057
Temp = &B00000011
I2cwbyte Temp                                               'SUBADRESS TSA6057

Temp = 0
I2cwbyte Temp                                               '  DB3

Freq_2 = Freq_1
Shift Freq_2 , Left , 1
Temp = Freq_2
Set Temp.0                                                  'CP -    
I2cwbyte Temp                                               '  DB0

Freq_2 = Freq_1
Shift Freq_2 , Right , 7
Temp = Freq_2
I2cwbyte Temp                                               '  DB1

Freq_2 = Freq_1
Shift Freq_2 , Right , 15
Temp = Freq_2
Set Temp.2                                                  'BS
Reset Temp.4                                                '/FM\AM OPAMP
Set Temp.5                                                  'FM/\AM
Reset Temp.6                                                'Ref1   1 
Reset Temp.7                                                'Ref2   1 
I2cwbyte Temp                                               '  DB2

I2cstop                                                     'I2C STOP

Return


End                                                         ' 