$crystal = 8000000                                          '   8

'  
Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.3 , Rs = Portb.2
Config Lcd = 16 * 2                                         ' 16  2 
Cursor Off                                                  ' 
Cls                                                         '  

Config Scl = Portb.0                                        ' I2C SCL
Config Sda = Portb.1                                        ' I2C SDA
Config I2cdelay = 10                                        '100 

Config Portd = Input                                        '   
Portd = 255                                                 '  

Const Tda = 136                                             ' SLAVE ADRESS TDA7313

' 
Dim M As Byte                                               ' 
Dim Datas(8) As Byte                                        ' 
Dim Max_sets As Byte                                        '   
Dim Temp As Byte                                            ' 


'    TDA7313
For M = 1 To 8
If M = 1 Then Datas(m) = 63                                 ' -70 dB
If M = 2 Then Datas(m) = 0                                  '   -14 dB
If M = 3 Then Datas(m) = 0                                  '   -14 dB
If M = 4 Then Datas(m) = 192                                ' LR = 0 dB
If M = 5 Then Datas(m) = 224                                ' RR = 0 dB
If M = 6 Then Datas(m) = 128                                ' LF = 0 dB
If M = 7 Then Datas(m) = 160                                ' RF = 0 dB
If M = 8 Then Datas(m) = 64                                 '1, LOUDNESS ,   = +11.25 dB
Gosub Write_data                                            '      TDA7313
Next

M = 1

Do                                                          '  

Locate 1 , 1                                                '   1 , 1 

If M = 1 Then                                               ' M=1    
            Lcd "Volume 63=-70dB"
            Max_sets = 63
End If


If M = 2 Then                                               ' M=2     
            Lcd "BASS"
            Max_sets = 15
End If

If M = 3 Then                                               ' M=3     
            Lcd "TREBLE"
            Max_sets = 15
End If

Locate 2 , 1                                                '   2 , 1 
Lcd Datas(m) ; "  "                                         '   


' 
If Pind.0 = 0 Then                                          '   S1
                    If Datas(m) > 0 Then Decr Datas(m)      '    0,    1
                    Gosub Write_data                        '      TDA7313
                    Waitms 100                              ' 100 
End If


If Pind.1 = 0 Then                                          '   S2
                    If Datas(m) < Max_sets Then Incr Datas(m)       '    Max_sets,    1
                    Gosub Write_data                        '      TDA7313
                    Waitms 100                              ' 100 
End If


' 
If Pind.2 = 0 Then                                          '   S3
                    If M > 1 Then Decr M                    '     1,    1
                    Cls                                     '  
                    Waitms 300                              ' 300 
End If


If Pind.3 = 0 Then                                          '   S4
                    If M < 3 Then Incr M                    '     3,    1
                    Cls                                     '  
                    Waitms 300                              ' 300 
End If

Loop                                                        '   

Write_data:                                                 ' I2C
'*******************************************************************************
Temp = Datas(m)
If M = 2 Then Temp = Datas(m) + 96
If M = 3 Then Temp = Datas(m) + 112

I2cstart                                                    'I2C START
I2cwbyte Tda                                                'SLAVE ADRESS TDA7313
I2cwbyte Temp                                               '   TDA7313
I2cstop                                                     'I2C STOP
Waitms 10                                                   ' 10 
Return

End                                                         ' 