$crystal = 8000000                                          '   8

'  
Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.3 , Rs = Portb.2
Config Lcd = 16 * 2                                         ' 16  2 
Cursor Off                                                  ' 
Cls                                                         '  

Config Scl = Portb.0                                        ' I2C SCL
Config Sda = Portb.1                                        ' I2C SDA
Config I2cdelay = 10                                        '100 

Config Portd = Input                                        '   
Portd = 255                                                 '  

Const Tda = 136                                             ' SLAVE ADRESS TDA7313
Const Tea = 132                                             ' SLAVE ADRESS TEA6360

' 
Dim M As Byte                                               ' 
Dim Datas(8) As Byte                                        ' 
Dim Boost(5) As Byte                                        ' 
Dim Cut(5) As Byte                                          ' 
Dim Max_sets As Byte                                        '   
Dim Temp As Byte                                            ' 
Dim Chip As Byte                                            '  
Dim Subadr As Byte                                          '  TEA6360
Dim Power_on As Bit                                         ' 


'    TDA7313
Chip = Tda                                                  'SLAVE ADRESS TDA7313

For M = 1 To 8
If M = 1 Then Datas(m) = 63                                 ' -70 dB
If M = 2 Then Datas(m) = 0                                  '   -14 dB
If M = 3 Then Datas(m) = 0                                  '   -14 dB
If M = 4 Then Datas(m) = 192                                ' LR = 0 dB
If M = 5 Then Datas(m) = 224                                ' RR = 0 dB
If M = 6 Then Datas(m) = 128                                ' LF = 0 dB
If M = 7 Then Datas(m) = 160                                ' RF = 0 dB
If M = 8 Then Datas(m) = 64                                 '1, LOUDNESS ,   = +11.25 dB


If M = 2 Then
            Temp = Datas(m) + 96
         Else
            If M = 3 Then
                        Temp = Datas(m) + 112
                     Else
                        Temp = Datas(m)
            End If
End If

Gosub Write_data                                            '      TDA7313
Next

Set Power_on                                                '  
M = 1

Do                                                          '  

Locate 1 , 1                                                '   1 , 1 

If M <= 5 Then
            Lcd "Filter " ; M                               ' 
            Locate 2 , 1                                    '   2 , 1 
            Lcd "Boost=" ; Boost(m) ; " Cut=" ; Cut(m) ; " "       '   
            Chip = Tea                                      ' SLAVE ADRESS TEA6360

            ' 
            If Pind.2 = 0 Then                              '   S3
                                If Boost(m) > 0 Then Boost(m) = Boost(m) - 16       '    0,    16
                                Gosub Write_data            '      TEA6360
                                Waitms 100                  ' 100 
            End If


            If Pind.3 = 0 Then                              '   S4
                                If Boost(m) < 112 Then Boost(m) = Boost(m) + 16       '    112,    16
                                Gosub Write_data            '      TEA6360
                                Waitms 100                  ' 100 
            End If

            If Pind.4 = 0 Then                              '   S5
                                If Cut(m) > 0 Then Decr Cut(m)       '    0,    1
                                Gosub Write_data            '      TEA6360
                                Waitms 100                  ' 100 
            End If


            If Pind.5 = 0 Then                              '   S6
                                If Cut(m) < 7 Then Incr Cut(m)       '    7,    1
                                Gosub Write_data            '      TEA6360
                                Waitms 100                  ' 100 
            End If
End If

If M = 6 Then                                               ' M=1    
            Lcd "Volume 63=-70dB"
            Max_sets = 63
            Chip = Tda                                      'SLAVE ADRESS TDA7313
            Locate 2 , 1                                    '   2 , 1 
            Lcd Datas(1) ; "  "                             '   

            ' 
            If Pind.2 = 0 Then                              '   S3
                                If Datas(1) > 0 Then Decr Datas(1)       '    0,    1
                                Temp = Datas(1)
                                Gosub Write_data            '      TDA7313
                                Waitms 100                  ' 100 
            End If


            If Pind.3 = 0 Then                              '   S4
                                If Datas(1) < Max_sets Then Incr Datas(1)       '    Max_sets,    1
                                Temp = Datas(1)
                                Gosub Write_data            '      TDA7313
                                Waitms 100                  ' 100 
            End If
End If

' 
If Pind.0 = 0 Then                                          '   S1
                    If M > 1 Then Decr M                    '     1,    1
                    Cls                                     '  
                    Waitms 300                              ' 300 
End If


If Pind.1 = 0 Then                                          '   S2
                    If M < 6 Then Incr M                    '     3,    1
                    Cls                                     '  
                    Waitms 300                              ' 300 
End If

Loop                                                        '   

Write_data:                                                 ' I2C
'*******************************************************************************
I2cstart                                                    'I2C START
I2cwbyte Chip                                               'SLAVE ADRESS TDA7313  TEA6360

If M <= 5 And Power_on = 1 Then                             '       
                             Subadr = M - 1
                             Temp = Boost(m) + Cut(m)
                             I2cwbyte Subadr                'SUBADRESS  TEA6360
End If

I2cwbyte Temp                                               '   TDA7313   TEA6360
I2cstop                                                     'I2C STOP
Waitms 10                                                   ' 10 
Return

End                                                         ' 