$crystal = 8000000                                          '   8

'  
Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.3 , Rs = Portb.2
Config Lcd = 16 * 2                                         ' 16  2 
Cursor Off                                                  ' 
Cls                                                         '  

Config Scl = Portb.0                                        ' I2C SCL
Config Sda = Portb.1                                        ' I2C SDA

Config Portd = Input                                        '   
Portd = 255                                                 '  

Const Tea6300 = 128                                         ' SLAVE ADRESS TEA6300
Const Tea6360 = 132                                         ' SLAVE ADRESS TEA6360

' 
Dim M As Byte                                               ' 
Dim Datas(6) As Byte                                        ' 
Dim Boost(5) As Byte                                        ' 
Dim Cut(5) As Byte                                          ' 
Dim Max_sets As Byte                                        '   
Dim Subadr As Byte                                          ' 
Dim Temp As Byte                                            ' 
Dim Chip As Byte                                            '  
Dim Power_on As Bit                                         ' 

'    TEA6300
Chip = Tea6300                                              ' SLAVE ADRESS TEA6300

For M = 1 To 6
Subadr = M - 1
If Subadr = 4 Then                                          '     (FADER)
                Datas(m) = 63                               'FADER FRONT 
                Temp = Datas(m)
                Gosub Write_data                            '      TEA6300
                Datas(m) = 47                               'FADER REAR 
              Else
                If Subadr = 5 Then                          '      MUTE
                                Datas(m) = 1                '  INLA, INRA, MUTE 
                              Else
                                Datas(m) = 0                '   0
                End If
End If
Temp = Datas(m)
Gosub Write_data                                            '      TEA6300
Next

Set Power_on                                                '  
M = 1


Do                                                          '  

Locate 1 , 1                                                '   1 , 1 

If M <= 5 Then
            Lcd "Filter " ; M                               ' 
            Locate 2 , 1                                    '   2 , 1 
            Lcd "Boost=" ; Boost(m) ; " Cut=" ; Cut(m) ; " "       '   
            Chip = Tea6360                                  ' SLAVE ADRESS TEA6360

            ' 
            If Pind.2 = 0 Then                              '   S3
                                If Boost(m) > 0 Then Boost(m) = Boost(m) - 16       '    0,    16
                                Gosub Write_data            '      TEA6360
                                Waitms 100                  ' 100 
            End If


            If Pind.3 = 0 Then                              '   S4
                                If Boost(m) < 112 Then Boost(m) = Boost(m) + 16       '    112,    16
                                Gosub Write_data            '      TEA6360
                                Waitms 100                  ' 100 
            End If

            If Pind.4 = 0 Then                              '   S5
                                If Cut(m) > 0 Then Decr Cut(m)       '    0,    1
                                Gosub Write_data            '      TEA6360
                                Waitms 100                  ' 100 
            End If


            If Pind.5 = 0 Then                              '   S6
                                If Cut(m) < 7 Then Incr Cut(m)       '    7,    1
                                Gosub Write_data            '      TEA6360
                                Waitms 100                  ' 100 
            End If
End If


If M = 6 Then                                               ' M=1      
            Lcd "Volume L-R"
            Max_sets = 63
            Chip = Tea6300                                  ' SLAVE ADRESS TEA6300
            Locate 2 , 1                                    '   2 , 1 
            Lcd Datas(1) ; "  "                             '   

            ' 
            If Pind.2 = 0 Then                              '   S3
                                If Datas(1) > 0 Then Decr Datas(1)       '    0,    1
                                Temp = Datas(1)
                                Subadr = 0                  '    
                                Gosub Write_data            '      TEA6300
                                Subadr = 1                  '    
                                Gosub Write_data            '      TEA6300
                                Waitms 100                  ' 100 
            End If


            If Pind.3 = 0 Then                              '   S4
                                If Datas(1) < Max_sets Then Incr Datas(1)       '    Max_sets,    1
                                Temp = Datas(1)
                                Subadr = 0                  '     
                                Gosub Write_data            '      TEA6300
                                Subadr = 1                  '    
                                Gosub Write_data            '      TEA6300
                                Waitms 100                  ' 100 
            End If

End If


' 
If Pind.0 = 0 Then                                          '   S1
                    If M > 1 Then Decr M                    '     1,    1
                    Cls                                     '  
                    Waitms 300                              ' 300 
End If


If Pind.1 = 0 Then                                          '   S2
                    If M < 6 Then Incr M                    '     3,    1
                    Cls                                     '  
                    Waitms 300                              ' 300 
End If

Loop                                                        '   

Write_data:                                                 ' I2C
'*******************************************************************************
I2cstart                                                    'I2C START
I2cwbyte Chip                                               'SLAVE ADRESS TEA6300  TEA6360

If M <= 5 And Power_on = 1 Then                             '       
                              Temp = Boost(m) + Cut(m)
                              Subadr = M - 1
End If

I2cwbyte Subadr                                             'SUBADRESS  TEA6300  TEA6360
I2cwbyte Temp                                               '   TEA6300   TEA6360
I2cstop                                                     'I2C STOP
Waitms 10                                                   ' 10 
Return


End                                                         ' 