$crystal = 8000000                                          '   8

'  
Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.3 , Rs = Portb.2
Config Lcd = 16 * 2                                         ' 16  2 
Cursor Off                                                  ' 
Cls                                                         '  

Config Scl = Portb.0                                        ' I2C SCL
Config Sda = Portb.1                                        ' I2C SDA
Config I2cdelay = 10                                        '100 

Config Portd = Input                                        '   
Portd = 255                                                 '  

Const Tea = 132                                             ' SLAVE ADRESS TEA6360

' 
Dim M As Byte                                               ' 
Dim Boost(5) As Byte                                        ' 
Dim Cut(5) As Byte                                          ' 
Dim Max_sets As Byte                                        '   
Dim Subadr As Byte                                          '  TEA6360
Dim Temp As Byte                                            ' 

'    TEA6360
For M = 1 To 5
Boost(m) = 0                                                ' 
Cut(m) = 0                                                  ' 
Gosub Write_data                                            '      TEA6360
Next

M = 1

Do                                                          '  

Locate 1 , 1                                                '   1 , 1 

Lcd "Filter " ; M                                           ' 
Locate 2 , 1                                                '   2 , 1 
Lcd "Boost=" ; Boost(m) ; " Cut=" ; Cut(m) ; " "            '   


' 
If Pind.0 = 0 Then                                          '   S1
                    If M > 1 Then Decr M                    '     1,    1
                    Cls                                     '  
                    Waitms 300                              ' 300 
End If


If Pind.1 = 0 Then                                          '   S2
                    If M < 5 Then Incr M                    '     3,    1
                    Cls                                     '  
                    Waitms 300                              ' 300 
End If

' 
If Pind.2 = 0 Then                                          '   S3
                    If Boost(m) > 0 Then Boost(m) = Boost(m) - 16       '    0,    16
                    Gosub Write_data                        '      TEA6360
                    Waitms 100                              ' 100 
End If


If Pind.3 = 0 Then                                          '   S4
                    If Boost(m) < 112 Then Boost(m) = Boost(m) + 16       '    112,    16
                    Gosub Write_data                        '      TEA6360
                    Waitms 100                              ' 100 
End If

If Pind.4 = 0 Then                                          '   S5
                    If Cut(m) > 0 Then Decr Cut(m)          '    0,    1
                    Gosub Write_data                        '      TEA6360
                    Waitms 100                              ' 100 
End If


If Pind.5 = 0 Then                                          '   S6
                    If Cut(m) < 7 Then Incr Cut(m)          '    7,    1
                    Gosub Write_data                        '      TEA6360
                    Waitms 100                              ' 100 
End If

Loop                                                        '   

Write_data:                                                 ' I2C
'*******************************************************************************
Subadr = M - 1
Temp = Boost(m) + Cut(m)

I2cstart                                                    'I2C START
I2cwbyte Tea                                                'SLAVE ADRESS TEA6360
I2cwbyte Subadr                                             'SUBADRESS  TEA6360
I2cwbyte Temp                                               '   TEA6360
I2cstop                                                     'I2C STOP
Waitms 10                                                   ' 10 
Return

End                                                         ' 